Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class FloatValue

    java.lang.Object
      net.sf.saxon.value.Value<AtomicValue>
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.NumericValue
                  net.sf.saxon.value.FloatValue

All Implemented Interfaces:
  Comparable, PullEvent, GroundedValue<AtomicValue>, Item<AtomicValue>, ValueRepresentation<AtomicValue>, ConversionResult

    public final class FloatValue

extends NumericValue

A numeric (single precision floating point) value

Field Summary
`static FloatValue` | `NaN`
`static FloatValue` | `NEGATIVE_ZERO`
`static FloatValue` | `ONE`
`static FloatValue` | `ZERO`

Fields inherited from class net.sf.saxon.value.AtomicValue
`typeLabel`

Fields inherited from class net.sf.saxon.value.Value
`INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`FloatValue(float value)` Constructor supplying a float
`FloatValue(float value, AtomicType type)` Constructor supplying a float and an AtomicType, for creating a value that belongs to a user-defined subtype of xs:float.

Method Summary
`NumericValue` | `abs()` Get the absolute value as defined by the XPath abs() function
`NumericValue` | `ceiling()` Implement the XPath ceiling() function
`int` | `compareTo(long other)` Compare the value to a long
`int` | `compareTo(Object other)` Compare the value to another numeric value
`AtomicValue` | `copyAsSubType(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
`boolean` | `effectiveBooleanValue()` Get the effective boolean value
`static CharSequence` | `floatToString(float value)` Internal method used for conversion of a float to a string
`NumericValue` | `floor()` Implement the XPath floor() function
`CharSequence` | `getCanonicalLexicalRepresentation()` Get the canonical lexical representation as defined in XML Schema.
`BigDecimal` | `getDecimalValue()` Get the numeric value converted to a decimal
`double` | `getDoubleValue()` Get the numeric value as a double
`float` | `getFloatValue()` Get the value
`CharSequence` | `getPrimitiveStringValue()` Get the value as a String
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`Comparable` | `getSchemaComparable()` Get an object that implements XML Schema comparison semantics
`int` | `hashCode()` Get the hashCode.
`boolean` | `isIdentical(Value v)` Determine whether two atomic values are identical, as determined by XML Schema rules.
`boolean` | `isNaN()` Test whether the value is the double/float value NaN
`boolean` | `isWholeNumber()` Determine whether the value is a whole number, that is, whether it compares equal to some integer
`long` | `longValue()` Return the numeric value as a Java long.
`static FloatValue` | `makeFloatValue(float value)` Static factory method (for convenience in compiled bytecode)
`NumericValue` | `negate()` Negate the value
`NumericValue` | `round(int scale)` Implement the XPath round() function
`NumericValue` | `roundHalfToEven(int scale)` Implement the XPath round-to-half-even() function
`int` | `signum()` Determine whether the value is negative, zero, or positive

Methods inherited from class net.sf.saxon.value.NumericValue
`equals, getXPathComparable, isInteger, parseNumber, toString`

Methods inherited from class net.sf.saxon.value.AtomicValue
`asAtomic, checkPermittedContents, getCardinality, getComponent, getItemType, getLength, getStringValue, getStringValueCS, getTypedValue, getTypeLabel, itemAt, iterate, process, setTypeLabel, subsequence`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convertToJava, fromItem, getIterator, getSequenceLength, reduce`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### ZERO

    public static final FloatValue ZERO

### NEGATIVE_ZERO

    public static final FloatValue NEGATIVE_ZERO

### ONE

    public static final FloatValue ONE

### NaN

    public static final FloatValue NaN

Constructor Detail

### FloatValue

    public FloatValue(float value)

  Constructor supplying a float

  Parameters:
    `value` - the value of the float

### FloatValue

    public FloatValue(float value,
                      AtomicType type)

  Constructor supplying a float and an AtomicType, for creating a value that belongs to a user-defined subtype of xs:float. It is the caller's responsibility to ensure that the supplied value conforms to the supplied type.

  Parameters:
    `value` - the value of the NumericValue
    `type` - the type of the value. This must be a subtype of xs:float, and the value must conform to this type. The method does not check these conditions.

Method Detail

### makeFloatValue

    public static FloatValue makeFloatValue(float value)

  Static factory method (for convenience in compiled bytecode)

  Parameters:
    `value` - the value of the float
  Returns:
    the FloatValue

### copyAsSubType

    public AtomicValue copyAsSubType(AtomicType typeLabel)

  Create a copy of this atomic value, with a different type label

  Specified by:
    `copyAsSubType` in class `AtomicValue`
  Parameters:
    `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.
  Returns:
    the copied value

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Specified by:
    `getPrimitiveType` in class `AtomicValue`
  Returns:
    the primitive type

### getFloatValue

    public float getFloatValue()

  Get the value

  Specified by:
    `getFloatValue` in class `NumericValue`
  Returns:
    a float representing this numeric value; NaN if it cannot be converted

### getDoubleValue

    public double getDoubleValue()

  Description copied from class: `NumericValue`
  Get the numeric value as a double

  Specified by:
    `getDoubleValue` in class `NumericValue`
  Returns:
    A double representing this numeric value; NaN if it cannot be converted

### getDecimalValue

    public BigDecimal getDecimalValue()
                               throws XPathException

  Get the numeric value converted to a decimal

  Specified by:
    `getDecimalValue` in class `NumericValue`
  Returns:
    a decimal representing this numeric value;
  Throws:
    `XPathException` - if the value cannot be converted, for example if it is NaN or infinite

### longValue

    public long longValue()
                   throws XPathException

  Return the numeric value as a Java long.

  Specified by:
    `longValue` in class `NumericValue`
  Returns:
    the numeric value as a Java long. This performs truncation towards zero.
  Throws:
    `XPathException` - if the value cannot be converted

### hashCode

    public int hashCode()

  Get the hashCode. This must conform to the rules for other NumericValue hashcodes

  Specified by:
    `hashCode` in class `NumericValue`
  Returns:
    the hash code of the numeric value
  See Also:
    `NumericValue.hashCode()`

### isNaN

    public boolean isNaN()

  Test whether the value is the double/float value NaN

  Overrides:
    `isNaN` in class `AtomicValue`
  Returns:
    true if the value is float NaN or double NaN or precisionDecimal NaN; otherwise false

### effectiveBooleanValue

    public boolean effectiveBooleanValue()

  Get the effective boolean value

  Overrides:
    `effectiveBooleanValue` in class `AtomicValue`
  Returns:
    true unless the value is zero or NaN

### getPrimitiveStringValue

    public CharSequence getPrimitiveStringValue()

  Get the value as a String

  Specified by:
    `getPrimitiveStringValue` in class `AtomicValue`
  Returns:
    a String representation of the value

### getCanonicalLexicalRepresentation

    public CharSequence getCanonicalLexicalRepresentation()

  Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules. For xs:float, the canonical representation always uses exponential notation.

  Overrides:
    `getCanonicalLexicalRepresentation` in class `Value<AtomicValue>`
  Returns:
    the canonical lexical representation if defined in XML Schema; otherwise, the result of casting to string according to the XPath 2.0 rules

### floatToString

    public static CharSequence floatToString(float value)

  Internal method used for conversion of a float to a string

  Parameters:
    `value` - the actual value
  Returns:
    the value converted to a string, according to the XPath casting rules.

### negate

    public NumericValue negate()

  Negate the value

  Specified by:
    `negate` in class `NumericValue`
  Returns:
    a value, of the same type as the original, with its sign inverted

### floor

    public NumericValue floor()

  Implement the XPath floor() function

  Specified by:
    `floor` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards minus infinity

### ceiling

    public NumericValue ceiling()

  Implement the XPath ceiling() function

  Specified by:
    `ceiling` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards plus infinity

### round

    public NumericValue round(int scale)

  Implement the XPath round() function

  Specified by:
    `round` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards the nearest whole number (0.5 rounded up)

### roundHalfToEven

    public NumericValue roundHalfToEven(int scale)

  Implement the XPath round-to-half-even() function

  Specified by:
    `roundHalfToEven` in class `NumericValue`
  Parameters:
    `scale` - the decimal position for rounding: e.g. 2 rounds to a multiple of 0.01, while -2 rounds to a multiple of 100
  Returns:
    a value, of the same type as the original, rounded towards the nearest multiple of 10**(-scale), with rounding towards the nearest even number if two values are equally near

### signum

    public int signum()

  Determine whether the value is negative, zero, or positive

  Specified by:
    `signum` in class `NumericValue`
  Returns:
    -1 if negative, 0 if zero (including negative zero), +1 if positive, NaN if NaN

### isWholeNumber

    public boolean isWholeNumber()

  Determine whether the value is a whole number, that is, whether it compares equal to some integer

  Specified by:
    `isWholeNumber` in class `NumericValue`
  Returns:
    true if the value is a whole number

### abs

    public NumericValue abs()

  Get the absolute value as defined by the XPath abs() function

  Specified by:
    `abs` in class `NumericValue`
  Returns:
    the absolute value
  Since:
    9.2

### compareTo

    public int compareTo(Object other)

  Description copied from class: `NumericValue`
  Compare the value to another numeric value

  Specified by:
    `compareTo` in interface `Comparable`
  Overrides:
    `compareTo` in class `NumericValue`
  Parameters:
    `other` - The other numeric value
  Returns:
    -1 if this one is the lower, 0 if they are numerically equal, +1 if this one is the higher, or if either value is NaN. Where NaN values are involved, they should be handled by the caller before invoking this method.

### compareTo

    public int compareTo(long other)

  Compare the value to a long

  Specified by:
    `compareTo` in class `NumericValue`
  Parameters:
    `other` - the value to be compared with
  Returns:
    -1 if this is less, 0 if this is equal, +1 if this is greater or if this is NaN

### getSchemaComparable

    public Comparable getSchemaComparable()

  Get an object that implements XML Schema comparison semantics

  Specified by:
    `getSchemaComparable` in class `AtomicValue`
  Returns:
    a Comparable that follows XML Schema comparison rules

### isIdentical

    public boolean isIdentical(Value v)

  Determine whether two atomic values are identical, as determined by XML Schema rules. This is a stronger test than equality (even schema-equality); for example two dateTime values are not identical unless they are in the same timezone.

  Note that even this check ignores the type annotation of the value. The integer 3 and the short 3 are considered identical, even though they are not fully interchangeable. "Identical" means the same point in the value space, regardless of type annotation.

  NaN is identical to itself.

  Overrides:
    `isIdentical` in class `AtomicValue`
  Parameters:
    `v` - the other value to be compared with this one
  Returns:
    true if the two values are identical, false otherwise.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.